import java.awt.*;
import java.awt.event.*;

public class ChartCanvas extends Canvas implements MouseMotionListener
{
	Chart applet;
	private int nPrePointX, nPrePointY, nPointX, nPointY, nOriginX; 
	private boolean pointFlag;
	private Image backImg;
	private Graphics G;

	ChartCanvas(Chart applet)
	{
		this.applet = applet;
		setBackground(Color.white);
	}

	public void sbChanged(Scrollbar scrollbar)
    {
        nOriginX = -scrollbar.getValue() * 30;
        repaint();
    }

	public void mouseMoved(MouseEvent e)
	{
		nPointX = e.getX();
		nPointY = e.getY();
//		if(nPointX != nPrePointX || nPointY != nPrePointY)
//		{
			drawMoveXLine(nPointX);
			drawMoveYLine(nPointY);
//		}
		nPrePointX = nPointX;
		nPrePointY = nPointY;
	}

	public void mouseDragged(MouseEvent e)
	{
		nPointX = e.getX();
		nPointY = e.getY();
//		if(nPointX != nPrePointX || nPointY != nPrePointY)
//		{
			drawMoveXLine(nPointX);
			drawMoveYLine(nPointY);
//		}
		nPrePointX = nPointX;
		nPrePointY = nPointY;
	}

	public void drawMoveXLine(int i)
	{
		Graphics g = getGraphics();
		g.setColor(Color.black);
		g.setXORMode(Color.white);
        if(!pointFlag)
	        g.drawLine(nPrePointX, 1, nPrePointX, getSize().height - 15);
		g.drawLine(i, 1, i, getSize().height - 15);
		pointFlag = false;
		g.dispose();
	}

	public void drawMoveYLine(int i)
	{
		Graphics g = getGraphics();
		g.setColor(Color.black);
		g.setXORMode(Color.white);
        if(!pointFlag)
			g.drawLine(1, nPrePointY, getSize().width - 1, nPrePointY);
		g.drawLine(1, i, getSize().width - 1, i);
		pointFlag = false;
		g.dispose();
	}

	public void setDBuf()
	{
		backImg = createImage(getSize().width, getSize().height);
		G = backImg.getGraphics();
	}

	public void setOrigin()
    {
        G.translate(nOriginX, 0);
	}

	public void setOutLine()
	{
		G.setColor(Color.black);
		G.drawRect(1 - nOriginX, 1, getSize().width - 2, getSize().height - 30);
	}

	public void setGrid(FontMetrics fm)
	{
		G.setColor(Color.lightGray);

		//򼱱׸
		for(int i = 0; i < 6 ; i++)
			G.drawLine(2-nOriginX, (int)(getSize().height * i / 6), getSize().width - 2-nOriginX, (int)(getSize().height * i / 6));

		//X ׸
		G.drawLine(-nOriginX, getSize().height - 20,getSize().width - 15 -nOriginX, getSize().height - 20);
		G.drawString("", getSize().width - 15 -nOriginX, getSize().height - 20 + (int)(fm.getHeight() / 2)- 1);

		//׸
	}
	public void setRange()
	{
		applet.naxismax = applet.naxismin = 0;
		for(int i=0; i < applet.vtDay.size() && i < applet.vtSent.size() && i < applet.vtRecv.size() ; i++)
		{
			if( i == 0 )
				applet.naxismin = (Integer.parseInt((String)applet.vtSent.elementAt(i)) < Integer.parseInt((String)applet.vtRecv.elementAt(i)) ?
					Integer.parseInt((String)applet.vtSent.elementAt(i)) : Integer.parseInt((String)applet.vtRecv.elementAt(i)));
			if( i > (int)(-nOriginX / 30) && i < (int)((-nOriginX + getSize().width) / 30) )
			{
				if(Integer.parseInt((String)applet.vtSent.elementAt(i)) > applet.naxismax)
					applet.naxismax = Integer.parseInt((String)applet.vtSent.elementAt(i));
				if(Integer.parseInt((String)applet.vtRecv.elementAt(i)) > applet.naxismax)
					applet.naxismax = Integer.parseInt((String)applet.vtRecv.elementAt(i));
				if(Integer.parseInt((String)applet.vtSent.elementAt(i)) < applet.naxismin)
					applet.naxismin = Integer.parseInt((String)applet.vtSent.elementAt(i));
				if(Integer.parseInt((String)applet.vtRecv.elementAt(i)) < applet.naxismin)
					applet.naxismin = Integer.parseInt((String)applet.vtRecv.elementAt(i));
			}
		}
		applet.axisCanvas.repaint();
	}
	public void drawData()
	{
		//Ÿ ׸
		int nSent = 0, nRecv = 0, nPreSent = 0, nPreRecv = 0;
		float nSentRatio = 0.0f, nRecvRatio= 0.0f;
		int ndrawheight = (int)(getSize().height * 2 / 3);
		int ndrawgap = (int)(getSize().height / 6);
		int nrange = applet.naxismax - applet.naxismin;
		for(int i=0; i < applet.vtDay.size() && i < applet.vtSent.size() && i < applet.vtRecv.size() ; i++)
		{
			nSentRatio = (float)((float)(applet.naxismax - Integer.parseInt((String)applet.vtSent.elementAt(i))) / nrange);
			nSent = (int)(nSentRatio * ndrawheight) + ndrawgap;
			nRecvRatio = (float)((float)(applet.naxismax - Integer.parseInt((String)applet.vtRecv.elementAt(i))) / nrange);
			nRecv = (int)(nRecvRatio * ndrawheight) + ndrawgap;
//			System.out.println(nSentRatio +" " + nSent + " " + nRecvRatio + " " + nRecv);   
			
			if(applet.strType.equals("0"))
			{
				G.setColor(Color.blue);
				G.fillRect( i * 30 + 20 - 1, nSent - 1, 3, 3);
				G.setColor(Color.red);
				G.fillRect( i * 30 + 20 - 1, nRecv - 1, 3, 3);
				if(i > 0)
				{
					G.setColor(Color.blue);
					G.drawLine( (i - 1) * 30 + 20 ,nPreSent , i * 30 + 20, nSent);
					G.setColor(Color.red);
					G.drawLine( (i - 1) * 30 + 20, nPreRecv , i * 30 + 20, nRecv);
				}
			}
			if(applet.strType.equals("1"))
			{
				G.setColor(new Color(100,100,255));
				if(Integer.parseInt((String)applet.vtSent.elementAt(i)) == applet.naxismin)
					G.drawLine( i * 30 + 20 - 10, nSent, i * 30 + 20 - 1, nSent);
				else
				{
					G.fillRect( i * 30 + 20 - 10, nSent, 9, -(nSent - (int)(getSize().height * 5 / 6)));
					G.setColor(Color.black);
					G.drawRect( i * 30 + 20 - 10, nSent, 9, -(nSent - (int)(getSize().height * 5 / 6)));
				}
				G.setColor(new Color(255,100,100));
				if(Integer.parseInt((String)applet.vtRecv.elementAt(i)) == applet.naxismin)
					G.drawLine( i * 30 + 20 + 1, nRecv, i * 30 + 20 + 10, nRecv);
				else
				{
					G.fillRect( i * 30 + 20 + 1, nRecv, 9,  -(nRecv - (int)(getSize().height * 5 / 6)));	
					G.setColor(Color.black);
					G.drawRect( i * 30 + 20 + 1, nRecv, 9,  -(nRecv - (int)(getSize().height * 5 / 6)));	
				}
			}
			G.setColor(Color.black);
			G.drawString((String)(applet.vtDay.elementAt(i)),i * 30 + 20 - 8,getSize().height - 4);
			G.drawString("day", getSize().width - 25 - nOriginX, getSize().height - 40);
			G.drawString(applet.strYear, 5 - nOriginX, getSize().height - 52);
			G.drawString(applet.strMonth, 5 - nOriginX, getSize().height - 40);
		
			nPreSent = nSent;
			nPreRecv = nRecv;
		}
	}

	public void paint(Graphics g)
	{
		FontMetrics fm = g.getFontMetrics(g.getFont());
		setDBuf();
		setOrigin();
		setOutLine();
		setGrid(fm);
		setRange();

		drawData();	

		g.drawImage(backImg, 0, 0, this);
		G.dispose();
		backImg.flush();
		pointFlag = true;
	}
}